#!/usr/bin/perl


use strict;

my $data_file = shift;

if (! $data_file)
  {
    my @list = </sys/bus/usb/drivers/taz_data_meter/*/protocol_test>;
    $data_file = pop @list;
  }

my $ans = {};

my $min = 10;
my $max = 250;

for (my $i=$min; $i<$max; $i=$i+5)
  {
    open(OUT,">$data_file") || die "Cannot open output file: $data_file";
    print OUT $i, "\n";
    close(OUT);
  
    
    print "TEST: $i\n";
    sleep(1);

    for (my $j = 0; $j<1000; $j++)
      {
        open(IN,"<$data_file") || die "Cannot open input file: $data_file";
        my $line = <IN>;
        close(IN);

        my ($value) = ($line =~ /(\d+)/);

        $ans->{ $i }->{ 'data'}->{ $value }++;
        $ans->{ $i }->{ 'total' }++;
        
      }
  }

for (my $i=$min; $i<$max; $i=$i+5)
  {
    print "\n";
    my $total = $ans->{ $i }->{ 'total' };
    foreach my $key (sort { $a <=> $b } (keys %{ $ans->{ $i }->{ 'data' } }))
      {
        my $count = $ans->{ $i }->{ 'data' }->{ $key }; 
        my $pct = int(100*$count/$total);
        print "$i\t$key = $count\t$pct\%\n";
      } 
  }

for (my $i=$min; $i<$max; $i=$i+5)
  {
    print "\n";
    my $total = $ans->{ $i }->{ 'total' };
    my $sum = 0;
    foreach my $key (sort { $a <=> $b } (keys %{ $ans->{ $i }->{ 'data' } }))
      {
        my $count = $ans->{ $i }->{ 'data' }->{ $key }; 
        $sum = $sum + $key*$count;
      } 
    my $avg = int(10*$sum/$total)/10;
    print "AVG: " , $i, "\t", $avg,"\n";
  }

