/******************************************************************************
 *
 *               Microchip Memory Disk Drive File System
 *
 ******************************************************************************
 * FileName:        FS Phys Interface Template.c
 * Dependencies:    TEMPLATEFILE.h
 *					string.h
 *                  FSIO.h
 *                  FSDefs.h
 * Processor:       None
 * Compiler:        None
 * Company:         Microchip Technology, Inc.
 * Version:         1.0.0
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the Company) for its PICmicro Microcontroller is intended and
 * supplied to you, the Companys customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in violation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
*****************************************************************************/

#include "Compiler.h"
#include "MDD File System\FSIO.h"
#include "MDD File System\FSDefs.h"
#include "string.h"
#include "MDD File System\internal flash.h"
#include "HardwareProfile.h"

/*************************************************************************/
/*  Note:  This file is included as a template of a C file for           */
/*         a new physical layer. It is designed to go with               */
/*         "TEMPLATEFILE.h"                                              */
/*************************************************************************/

#define FAT_LITE
/******************************************************************************
 * Global Variables
 *****************************************************************************/
#ifdef USE_PIC18
	#pragma udata myBuff
#endif

#if !defined(FAT_LITE)
BYTE gDataBuffer[MEDIA_SECTOR_SIZE];
#endif

#ifdef USE_PIC18
	#pragma udata
	#pragma code
#endif

#ifdef USE_PIC18
	#pragma udata FATBuff
#endif

#if !defined(FAT_LITE)
BYTE gFATBuffer[MEDIA_SECTOR_SIZE];
#endif

#ifdef USE_PIC18
	#pragma udata
	#pragma code
#endif

#if !defined(FAT_LITE)
DISK gDiskData;
#endif

#define FILES_ADDRESS 0x1000

#if defined(__18CXX)
#pragma romdata Files=0xC00
#endif
ROM BYTE __attribute__ ((address(0x8000),section("MDD_FILES"),space(psv))) MasterBootRecord[512] = 
{ 
//Code Area
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	//0x0000
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0010
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0020
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0030
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0040
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0050
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0060
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0070
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0080
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0090
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00A0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00B0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00C0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00D0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00E0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x00F0
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0100
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0110
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0120
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0130
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0140
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0150
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0160
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0170
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                                     //0x0180

//IBM 9 byte/entry x 4 entries primary partition table
0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                                                             //0x018A
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x0190
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,             //0x01A0

//???
0x00, 0x00,                                                                                     //0x01AE
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                                                 //0x01B0

//Disk signature
0xF5, 0x8B, 0x16, 0xEA,                                                                         //0x01B8

//??? - usually 0x0000
0x00, 0x00,                                                                                     //0x01BC

//Table of Primary Partitions (16 bytes/entry x 4 entries)
//Entry 1                                                                                       //0x01BE
0x80,                   //Status - 0x80 (bootable), 0x00 (not bootable), other (error)
0x01, 0x01, 0x00,       //Cylinder-head-sector address of first sector in partition
0x01,                   //Partition type - 0x06 = FAT16 32MB+
0x07, 0xFF, 0xE6,       //Cylinder-head-sector address of last sector in partition
0x01, 0x00, 0x00, 0x00, //Logical block address of first sector in partition
0x10, 0x00, 0x00, 0x00, //Length of partition in sectors
//Entry 2
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x01CE
//Entry 3
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x01DE
//Entry 4
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //0x01EE

//MBR signature
0x55, 0xAA                                                                                      //0x01FE
};

//Physical Sector - 1, Logical Sector - 0
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) BootSector[512]  =
{
0xEB, 0x3C, 0x90,			//Jump instruction
'M', 'S', 'D', 'O', 'S', '5', '.', '0',	//OEM Name "MSDOS5.0"
0x00, 0x02,	        //Bytes per sector - 512
0x01,			    //Sectors per cluster
0x01, 0x00,			//Reserved sector count
0x01,			    //number of FATs
0x10, 0x00,			//Max number of root directory entries - 16 files allowed
0x00, 0x00,			//total sectors
0xF8,			    //Media Descriptor
0x01, 0x00,         //Sectors per FAT
0x3F, 0x00,	        //Sectors per track
0xFF, 0x00,         //Number of heads
0x01, 0x00, 0x00, 0x00,		//Hidden sectors
0x10, 0x00, 0x00, 0x00,		//Total sectors

0x00,			//Physical drive number
0x00,			//Reserved("current head")
0x29,			//Signature
0x32, 0x67, 0x94, 0xC4,		//ID(serial number)
'N', 'O', ' ', 'N', 'A', 'M', 'E', ' ', ' ', ' ', ' ',	//Volume Label - "NO NAME    "
'F', 'A', 'T', '1', '6', ' ', ' ', ' ',	//FAT system "FAT16   "
//Operating system boot code
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	
0x55, 0xAA			//End of sector (0x55AA)
};

//Physical Sector - 2, Logical Sector - 1
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) FAT1[512] =
{ 
    0xF8,   //Copy of the media descriptor
};

//Physical Sector - 3, Logical Sector - 2
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) RootDirectory[512] =
{
    //Root
    'D','r','i','v','e',' ','N','a','m','e',' ',   //Drive Name (11 characters, padded with spaces)
    0x08, //specify this entry as a volume label
    0x00, //Reserved
    0x00, 0x00, 0x00, 0x00, 0x11, //Create time
    0x00, 0x11, //Last Access
    0x00, 0x00, //EA-index
    0x00, 0x00, 0x00, 0x11, //Last modified time
    0x00, 0x00, //First FAT16 cluster
    0x00, 0x00, 0x00, 0x00, //File Size
    
};

//Physical Sector - 4, Logical Sector - 3
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack0[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack1[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack2[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack3[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack4[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack5[512] = 
{
    0
};
ROM BYTE __attribute__((section("MDD_FILES"),space(psv))) slack6[512] = 
{
    0
};

/******************************************************************************
 * Prototypes
 *****************************************************************************/

BYTE DISKmount( DISK *dsk);
BYTE LoadMBR(DISK *dsk);
BYTE LoadBootSector(DISK *dsk);
extern void Delayms(BYTE milliseconds);
BYTE MediaInitialize(void);

#ifdef USE_PIC24
	BYTE ReadByte( BYTE* pBuffer, WORD index );
	WORD ReadWord( BYTE* pBuffer, WORD index );
	DWORD ReadDWord( BYTE* pBuffer, WORD index );	
#endif

/******************************************************************************
 * Function:        BYTE MediaDetect(void)
 *
 * PreCondition:    InitIO() function has been executed.
 *
 * Input:           void
 *
 * Output:          TRUE   - Card detected
 *                  FALSE   - No card detected
 *
 * Side Effects:    None
 *
 * Overview:        None
 *
 * Note:            None
 *****************************************************************************/
BYTE MediaDetect()
{
	return TRUE;
}//end MediaDetect

/******************************************************************************
 * Function:        WORD ReadSectorSize(void)
 *
 * PreCondition:    MediaInitialize() is complete
 *
 * Input:           void
 *
 * Output:          WORD - size of the sectors for this physical media.
 *
 * Side Effects:    None
 *
 * Overview:        None
 *
 * Note:            None
 *****************************************************************************/
WORD ReadSectorSize(void)
{
    return MEDIA_SECTOR_SIZE;
}

/******************************************************************************
 * Function:        DWORD ReadCapacity(void)
 *
 * PreCondition:    MediaInitialize() is complete
 *
 * Input:           void
 *
 * Output:          DWORD - size of the "disk"
 *
 * Side Effects:    None
 *
 * Overview:        None
 *
 * Note:            None
 *****************************************************************************/
DWORD ReadCapacity(void)
{
    //TODO: fix this to a variable that is acceptable
    return 0xA;
}

/******************************************************************************
 * Function:        BYTE InitIO(void)
 *
 * PreCondition:    None
 *
 * Input:           void
 *
 * Output:          TRUE   - Card initialized
 *                  FALSE   - Card not initialized
 *
 * Side Effects:    None
 *
 * Overview:        None
 *
 * Note:            None
 *****************************************************************************/
#if !defined(FAT_LITE)
BYTE InitIO (void)
{
	return  (DISKmount (&gDiskData) == CE_GOOD);
}
#endif
		

/******************************************************************************
 * Function:        BYTE MediaInitialize(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          Returns TRUE if media is initialized, FALSE otherwise
 *
 * Overview:        MediaInitialize initializes the media card and supporting variables.
 *
 * Note:            None
 *****************************************************************************/
BYTE MediaInitialize(void)
{
	return TRUE;
}//end MediaInitialize


/******************************************************************************
 * Function:        BYTE SectorRead(DWORD sector_addr, BYTE *buffer)
 *
 * PreCondition:    None
 *
 * Input:           sector_addr - Sector address, each sector contains 512-byte
 *                  buffer      - Buffer where data will be stored, see
 *                                'ram_acs.h' for 'block' definition.
 *                                'Block' is dependent on whether internal or
 *                                external memory is used
 *
 * Output:          Returns TRUE if read successful, false otherwise
 *
 * Side Effects:    None
 *
 * Overview:        SectorRead reads 512 bytes of data from the card starting
 *                  at the sector address specified by sector_addr and stores
 *                  them in the location pointed to by 'buffer'.
 *
 * Note:            The device expects the address field in the command packet
 *                  to be byte address. Therefore the sector_addr must first
 *                  be converted to byte address. This is accomplished by
 *                  shifting the address left 9 times.
 *****************************************************************************/
BYTE SectorRead(DWORD sector_addr, BYTE* buffer)
{
    #if defined(__C30__)
        WORD PSVPageSave;
    
        PSVPageSave = PSVPAG;
        //TODO: fix this so it is not static but rather based on the requested sector
        PSVPAG = 0x01;
    #endif

    memcpypgm2ram
    (
        (void*)buffer, 
        (ROM void*)(&MasterBootRecord[0] + (sector_addr * MEDIA_SECTOR_SIZE)), 
        MEDIA_SECTOR_SIZE
    );

    #if defined(__C30__)
        PSVPAG = PSVPageSave;
    #endif

	return TRUE;
}//end SectorRead

/******************************************************************************
 * Function:        BYTE SectorWrite(DWORD sector_addr, BYTE *buffer, BYTE allowWriteToZero)
 *
 * PreCondition:    None
 *
 * Input:           sector_addr - Sector address, each sector contains 512-byte
 *                  buffer      - Buffer where data will be read
 *                  allowWriteToZero - If true, writes to the MBR will be valid
 *
 * Output:          Returns TRUE if write successful, FALSE otherwise
 *
 * Side Effects:    None
 *
 * Overview:        SectorWrite sends 512 bytes of data from the location
 *                  pointed to by 'buffer' to the card starting
 *                  at the sector address specified by sector_addr.
 *
 * Note:            The sample device expects the address field in the command packet
 *                  to be byte address. Therefore the sector_addr must first
 *                  be converted to byte address. This is accomplished by
 *                  shifting the address left 9 times.
 *****************************************************************************/
#if defined(__18CXX)
//#pragma udata myFileBuffer=0x600
#endif
volatile unsigned char file_buffer[ERASE_BLOCK_SIZE] __attribute__((far));
#if defined(__18CXX)
//#pragma udata
#endif

#if defined(__C30__)
    extern int  ReadPMHigh(int);
    extern int  ReadPMLow(int);
    extern void UnlockPM(void);
    extern int  WritePMHigh(int, int);
    extern int  WritePMHighB(int, int);
    extern int  WritePMLow(int, int);
    extern int  WritePMLowB(int, int);
#endif

void EraseBlock(BYTE* dest);
void WriteRow(void);
void WriteByte(unsigned char);

#define PROGRAM_WORD        0x4003
#define ERASE               0x4042
#define PROGRAM_PAGE        0x4001

BYTE *FileAddress = 0;

BYTE SectorWrite(DWORD sector_addr, BYTE* buffer, BYTE allowWriteToZero)
{
    ROM BYTE* dest;               
    BOOL foundDifference;
    WORD blockCounter;
    WORD sectorCounter;


    #if defined(__C30__)
    WORD PSVPageSave;
    WORD_VAL data;

    PSVPageSave = PSVPAG;
    //TODO: make this not a hardcoded value
    PSVPAG = 0x01;
    #endif
            
    if(sector_addr == 0x04)
    {
        Nop();
    }
   
    dest = (ROM BYTE*)(&MasterBootRecord[0] + (sector_addr * MEDIA_SECTOR_SIZE));
    
    sectorCounter = 0;

    while(sectorCounter < MEDIA_SECTOR_SIZE)
    {
        foundDifference = FALSE;
        for(blockCounter = 0; blockCounter < ERASE_BLOCK_SIZE; blockCounter++)
        {
            if(dest[sectorCounter] != buffer[sectorCounter])
            {
                foundDifference = TRUE;
                sectorCounter -= blockCounter;
                break;
            }
            sectorCounter++;
        }
        if(foundDifference == TRUE)
        {
            BYTE i,j;
            WORD address;

            #if (ERASE_BLOCK_SIZE >= MEDIA_SECTOR_SIZE)
                address = ((WORD)(dest + sectorCounter) & ~(ERASE_BLOCK_SIZE - 1));
    
                memcpypgm2ram
                (
                    (void*)file_buffer, 
                    (ROM void*)address, 
                    ERASE_BLOCK_SIZE
                );
    
                EraseBlock((BYTE*)address);
    
                address = ((WORD)(dest + sectorCounter) & (ERASE_BLOCK_SIZE - 1));
    
                memcpy
                (
                    (void*)(&file_buffer[address]), 
                    (void*)buffer, 
                    MEDIA_SECTOR_SIZE
                );

            #else

                address = ((WORD)(&dest[sectorCounter]) & ~(ERASE_BLOCK_SIZE - 1));
    
                EraseBlock((BYTE*)address);

                sectorCounter = sectorCounter & ~(ERASE_BLOCK_SIZE - 1);

                memcpy
                (
                    (void*)file_buffer, 
                    (void*)buffer+sectorCounter, 
                    ERASE_BLOCK_SIZE
                );
            #endif

            //sectorCounter = sectorCounter & ~(ERASE_BLOCK_SIZE - 1);

            i=ERASE_BLOCK_SIZE/WRITE_BLOCK_SIZE;
            j=0;
            while(i-->0)
            {
                //Write the new data
                for(blockCounter = 0; blockCounter < WRITE_BLOCK_SIZE; blockCounter++)
                {
                    //Write the data
                    #if defined(__18CXX)
                        TABLAT = file_buffer[(j * WRITE_BLOCK_SIZE) + blockCounter];
                        _asm tblwtpostinc _endasm
                    #endif
                
                    #if defined(__C30__)
                
                        if(((unsigned int)FileAddress & 0x01) == 0x01)
                        {
                            FileAddress--;
                            data.v[1] = file_buffer[sectorCounter];
                            WritePMLow(data.Val, (int)FileAddress);
                            WritePMHigh(0,(int)FileAddress);
                            FileAddress += 2;
                        }
                        else
                        {
                            data.v[0] = file_buffer[sectorCounter];
                            FileAddress++;
                        }
                    #endif

                    sectorCounter++;
                }

                j++;

                //write the row
                #if defined(__18CXX)
                    // Start the write process: reposition tblptr back into memory block that we want to write to.
                     _asm tblrdpostdec _endasm
                    
                    // Write flash memory, enable write control.
                    EECON1 = 0x84;
                    
                    EECON2 = 0x55;
                    EECON2 = 0xaa;
                    EECON1bits.WR = 1;
                    Nop();
                    EECON1bits.WREN = 0;
                    
                    TBLPTR++;
                #endif
                #if defined(__C30__)
                    NVMCON = PROGRAM_PAGE;
                    UnlockPM();
                #endif

                Nop();
                Nop();
            }
        }
    }

    #if defined(__C30__)
    PSVPAG = PSVPageSave;
    #endif

	return TRUE;
} //end SectorWrite

void EraseBlock(BYTE* dest)
{
    #if defined(__18CXX)
        TBLPTR = (unsigned short long)dest;
        
        //Erase the current block
        EECON1 = 0x94;
        
        EECON2 = 0x55;
        EECON2 = 0xaa;
        EECON1bits.WR = 1;
        
        EECON1bits.WREN = 0;
    #endif

    #if defined(__C30__)
        NVMCON = ERASE;
        WritePMLow(0, (int)dest);
        UnlockPM();
        FileAddress = dest;
        NVMCON = PROGRAM_PAGE;
    #endif
}
void WriteRow(void)
{

}

/******************************************************************************
 * Function:        BYTE WriteProtectState(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          BYTE    - Returns the status of the "write enabled" pin
 *
 * Side Effects:    None
 *
 * Overview:        Determines if the card is write-protected
 *
 * Note:            None
 *****************************************************************************/

BYTE WriteProtectState(void)
{
	return FALSE;
}

/******************************************************************************
 * Function:        BYTE DISKmount ( DISK *dsk)
 *
 * PreCondition:    InitIO function has been executed.
 *
 * Input:           dsk		- The disk to be mount
 *
 * Output:          CE_GOOD 		- Disk mounted
 *					CE_INIT_ERROR	- Initialization error has occured
 *
 * Side Effects:    None
 *
 * Overview:        Will mount only the first partition on the device
 *
 * Note:            None
 *****************************************************************************/
#if !defined(FAT_LITE)
BYTE DISKmount( DISK *dsk)
{
	BYTE        error = CE_GOOD;

	dsk->mount = FALSE; // default invalid
	dsk->buffer = gDataBuffer;    // assign buffer

	// Initialize the device
	if(MediaInitialize() != TRUE)
	{
		error = CE_INIT_ERROR;
	}
	else
	{
		// Load the Master Boot Record (partition)
		if((error = LoadMBR(dsk)) == CE_GOOD)
		{
			// Now the boot sector
			if((error = LoadBootSector(dsk)) == CE_GOOD)
				dsk->mount = TRUE; // Mark that the DISK mounted successfully
		}

	} // -- Initialize the device

	return(error);
} // -- mount
#endif

/******************************************************************************
 * Function:        CETYPE LoadMBR ( DISK *dsk)
 *
 * PreCondition:    Called from DISKmount
 *
 * Input:           dsk		- The disk containing the master boot record to be loaded
 *
 * Output:          CE_GOOD 			- MBR loaded successfully
 *                  CE_BAD_SECTOR_READ	- A bad read occured of a sector 
 *					CE_BAD_PARTITION	- The boot record is bad
 *
 * Side Effects:    None
 *
 * Overview:        Loads the MBR and extracts the necessary information
 *
 * Note:            None
 *****************************************************************************/
#if !defined(FAT_LITE)
BYTE LoadMBR(DISK *dsk)
{
    PT_MBR  Partition;
    BYTE error = CE_GOOD;
    BYTE type;
	BootSec BSec;

    // Get the partition table from the MBR
    if ( SectorRead( FO_MBR, dsk->buffer) != TRUE) 
        error = CE_BAD_SECTOR_READ;
    else
    {
		// Check if the card has no MBR
		BSec = (BootSec) dsk->buffer;

		if((BSec->Signature0 == FAT_GOOD_SIGN_0) && (BSec->Signature1 == FAT_GOOD_SIGN_1))
        {
			// Technically, the OEM name is not for indication
			// The alternative is to read the CIS from attribute
			// memory.  See the PCMCIA metaformat for more details
#ifdef USE_PIC24
            if (ReadByte( dsk->buffer, BSI_FSTYPE ) == 'F' && \
				ReadByte( dsk->buffer, BSI_FSTYPE + 1 ) == 'A' && \
				ReadByte( dsk->buffer, BSI_FSTYPE + 2 ) == 'T' && \
				ReadByte( dsk->buffer, BSI_FSTYPE + 3 ) == '1' && \
				ReadByte( dsk->buffer, BSI_BOOTSIG) == 0x29)
#else
			if (BSec->FAT.FAT_16.BootSec_FSType[0] == 'F' && \
				BSec->FAT.FAT_16.BootSec_FSType[1] == 'A' && \
				BSec->FAT.FAT_16.BootSec_FSType[2] == 'T' && \
				BSec->FAT.FAT_16.BootSec_FSType[3] == '1' && \
				BSec->FAT.FAT_16.BootSec_BootSig == 0x29)
#endif
			{
				dsk->firsts = 0;
				dsk->type = FAT16;
			}
        }
		// assign it the partition table strucutre
    	Partition = (PT_MBR)dsk->buffer;
    
        // Ensure its good
        if((Partition->Signature0 != FAT_GOOD_SIGN_0) || (Partition->Signature1 != FAT_GOOD_SIGN_1))
        {
            error = CE_BAD_PARTITION;
        }
        else
        {    
            /*    Valid Master Boot Record Loaded   */

            // Get the 32 bit offset to the first partition 
            dsk->firsts = Partition->Partition0.PTE_FrstSect; 

            // check if the partition type is acceptable
           	type = Partition->Partition0.PTE_FSDesc;

            switch (type)
            {
                case 0x01:
                    dsk->type = FAT12;
                    break;
               
				case 0x04:
                case 0x06:
                case 0x0E:
                    dsk->type = FAT16;
                    break;
                
                case 0x0B:
                case 0x0C:
                    dsk->type = FAT32; // and error out				
                    error = CE_CARDFAT32;
                    break;
                    
                default:
                    error = CE_BAD_PARTITION;
            } // switch
        }
    }

    return(error);
}// -- LoadMBR
#endif

/******************************************************************************
 * Function:        BYTE LoadBootSector (DISK *dsk)
 *
 * PreCondition:    Called from DISKmount
 *
 * Input:           dsk		- The disk containing the boot sector
 *                  
 * Output:          CE_GOOD 			- Boot sector loaded
 *                  CE_BAD_SECTOR_READ	- A bad read occured of a sector 
 *					CE_NOT_FORMATTED	- The disk is of an unsupported format
 *					CE_CARDFAT12		- FAT12 during intial testing we are not supporting FAT12
 *					CE_CARDFAT32		- FAT 32 - card not supported
 *
 * Side Effects:    None
 *
 * Overview:        Load the boot sector information and extract the necessary information
 *
 * Note:            None
 *****************************************************************************/

#if !defined(FAT_LITE)
BYTE LoadBootSector(DISK *dsk)
{
    WORD     RootDirSectors;
    DWORD     TotSec,DataSec;
    BYTE      error = CE_GOOD;
    BootSec		BSec;        // boot sector, assume its FAT16 til we know better

	WORD   BytesPerSec;
                    
    // Get the Boot sector
    if ( SectorRead( dsk->firsts, dsk->buffer) != TRUE) 

        error = CE_BAD_SECTOR_READ;  
    else
    {
        // Assign the type
        BSec = (BootSec)dsk->buffer;
    
        //Verify the Boot Sector is valid
        if((BSec->Signature0 != FAT_GOOD_SIGN_0) || (BSec->Signature1 != FAT_GOOD_SIGN_1))
        {
            error = CE_NOT_FORMATTED;
        }
        else
        {     
            // determine the number of sectors in one FAT
			#ifdef USE_PIC18
	            dsk->fatsize = BSec->FAT.FAT_16.BootSec_SPF;  
			#else
				dsk->fatsize = ReadWord( dsk->buffer, BSI_SPF ); 
			#endif

			// Figure out the total number of sectors
			#ifdef USE_PIC18
		        if(BSec->FAT.FAT_16.BootSec_TotSec16 != 0)
		        {
		            TotSec = BSec->FAT.FAT_16.BootSec_TotSec16;
		        }
	            else
	            {
	                TotSec = BSec->FAT.FAT_16.BootSec_TotSec32;
	            }
			#else
		        TotSec = ReadWord( dsk->buffer, BSI_TOTSEC16 );
				if( TotSec == 0 )
					TotSec = ReadDWord( dsk->buffer, BSI_TOTSEC32 );
			#endif
	            	                       

			#ifdef USE_PIC18
		        // get the full partition/drive layout
		        // determine the size of a cluster
		        dsk->SecPerClus = BSec->FAT.FAT_16.BootSec_SPC;
		        	        
		        // determine fat, root and data lbas
		        // FAT = first sector in partition (boot record) + reserved records
		        dsk->fat        = dsk->firsts + BSec->FAT.FAT_16.BootSec_ResrvSec;
		        
		        // fatcopy is the number of FAT tables 
		        dsk->fatcopy    = BSec->FAT.FAT_16.BootSec_FATCount;
	
		        // maxroot is the maximum number of entries in the root directory
		        dsk->maxroot    = BSec->FAT.FAT_16.BootSec_RootDirEnts;    
		        
	            // root is the sector location of the root directory
	            dsk->root = dsk->fat + (dsk->fatcopy * dsk->fatsize);
	
				BytesPerSec = BSec->FAT.FAT_16.BootSec_BPS;
	
				if( BytesPerSec == 0 || (BytesPerSec & 1) == 1 ) //cannot be 0 or odd
					return( CE_NOT_FORMATTED );
		                        
		        RootDirSectors = ((BSec->FAT.FAT_16.BootSec_RootDirEnts * 32) + (BSec->FAT.FAT_16.BootSec_BPS - 1)) / BSec->FAT.FAT_16.BootSec_BPS;

			#else

				dsk->SecPerClus = ReadByte( dsk->buffer, BSI_SPC );
		        	        
		        // determine fat, root and data lbas
		        // FAT = first sector in partition (boot record) + reserved records
		        dsk->fat        = dsk->firsts + ReadWord( dsk->buffer, BSI_RESRVSEC );
		        
		        // fatcopy is the number of FAT tables 
		        dsk->fatcopy    = ReadByte( dsk->buffer, BSI_FATCOUNT );
	
		        // maxroot is the maximum number of entries in the root directory
		        dsk->maxroot    = ReadWord( dsk->buffer, BSI_ROOTDIRENTS );   
		        
	            // root is the sector location of the root directory
	            dsk->root = dsk->fat + (dsk->fatcopy * dsk->fatsize);
	
				BytesPerSec = ReadWord( dsk->buffer, BSI_BPS );
	
				if( BytesPerSec == 0 || (BytesPerSec & 1) == 1 ) //cannot be 0 or odd
					return( CE_NOT_FORMATTED );
		                        
		        RootDirSectors = ((dsk->maxroot * 32) + (BytesPerSec - 1)) / BytesPerSec;               
			#endif
	
			// figure out how many data sectors there are
	        DataSec = TotSec - (dsk->root + RootDirSectors) + dsk->firsts + 2;
		        
		    dsk->maxcls = DataSec / dsk->SecPerClus;

	        // Calculate FAT type
	        if(dsk->maxcls < 4085)
	        {
	            /* Volume is FAT12 */
	            dsk->type = FAT12;
    	    }
    	    else 
			{
				if(dsk->maxcls < 65525)
	    	    {
	    	        /* Volume is FAT16 */
	    	        dsk->type = FAT16;
	    	    }
	    	    else
	    	        /* Volume is FAT32 */
	    	        // We don't support FAT32
	    	        error = CE_CARDFAT32;     
			}
	                	        
	        // DATA = ROOT + (MAXIMUM ROOT *32 / 512) 
	        dsk->data = dsk->root + ( dsk->maxroot >> 4); // assuming maxroot % 16 == 0
	        
	        // make sure that we can read in a complete sector
			#ifdef USE_PIC18
		        if(BSec->FAT.FAT_16.BootSec_BPS != MEDIA_SECTOR_SIZE)
			#else
		        if(BytesPerSec != MEDIA_SECTOR_SIZE)
			#endif
	            error = CE_NOT_FORMATTED;
		}
    }

	return(error);
}
#endif

#ifdef USE_PIC24

/******************************************************************************
 * Function:        BYTE ReadByte(BYTE * pBuffer, WORD index)
 *
 * PreCondition:    None
 *
 * Input:           pBuffer	- pointer to a buffer to read from
 *					index	- index in the buffer to read to
 *
 * Output:          BYTE	- the byte read
 *
 * Side Effects:    None
 *
 * Overview:        Reads a byte from a buffer
 *
 * Note:            None
 *****************************************************************************/


	BYTE ReadByte( BYTE* pBuffer, WORD index )
	{
		return( pBuffer[index] );
	}


/******************************************************************************
 * Function:        BYTE ReadWord(BYTE * pBuffer, WORD index)
 *
 * PreCondition:    None
 *
 * Input:           pBuffer	- pointer to a buffer to read from
 *					index	- index in the buffer to read to
 *
 * Output:          WORD	- the word read
 *
 * Side Effects:    None
 *
 * Overview:        Reads a 16-bit word from a buffer
 *
 * Note:            None
 *****************************************************************************/

	
	WORD ReadWord( BYTE* pBuffer, WORD index )
	{
		BYTE loByte, hiByte;
		WORD res;
	
		loByte = pBuffer[index];
		hiByte = pBuffer[index+1];
		res = hiByte;
		res *= 0x100;
		res |= loByte;
		return( res );
	}
	
/******************************************************************************
 * Function:        BYTE ReadDWord(BYTE * pBuffer, WORD index)
 *
 * PreCondition:    None
 *
 * Input:           pBuffer	- pointer to a buffer to read from
 *					index	- index in the buffer to read to
 *
 * Output:          DWORD	- the double word read
 *
 * Side Effects:    None
 *
 * Overview:        Reads a 32-bit double word from a buffer
 *
 * Note:            None
 *****************************************************************************/


	DWORD ReadDWord( BYTE* pBuffer, WORD index )
	{
		WORD loWord, hiWord;
		DWORD result;
	
		loWord = ReadWord( pBuffer, index );
		hiWord = ReadWord( pBuffer, index+2 );
	
		result = hiWord;
		result *= 0x10000;
		result |= loWord;
		return result;
	}
#endif



#ifdef ALLOW_FORMATS
#ifdef ALLOW_WRITES

/****************************************************************/
/*                    YOUR CODE HERE                            */
/*  Format is a device-specific function.  Some devices, like   */
/*  SD and CF cards, are programmed during manufacture with     */
/*  information about the card.  Other devices won't have those */
/*  features, and the information will have to be specified     */
/*  by the programmer or the user.  In the following example    */
/*  the user will provice the relevant values                   */
/****************************************************************/

/* Mode- 	0: Erase FAT and root directory
			1: Erase FAT and root, write new boot sector
			2: Erase FAT and root, write new boot sector and MBR
serialNumber	- The serial number of the volume. Used if mode == 1 or 2
volumeID		- The volume label.  Used if mode == 1 or 2
numSectors		- The number of sectors on the device
bootSecAddress	- The sector of the device the boot sec is located in
*/
#if !defined(FAT_LITE)
int format (char mode, long int serialNumber, char * volumeID, long int numsectors, long int bootSecAddress)
{

	PT_MBR	masterBootRecord;
	DWORD 	secCount, FAT16DataClusters, RootDirSectors;
	BootSec		BSec;
	DISK	d;
	DISK * disk = &d;
	WORD 	i, j;
	DWORD	fatsize, test;
	// Cylinder-head-sector structure
	struct
	{
		WORD cylinder;
		BYTE head;
		BYTE sector;
	} CHS;

	disk->buffer = gDataBuffer;

	// Initialize the card
	InitIO();
	if (MediaInitialize() != TRUE)
		return EOF;

	// Check if we're making our own MBR
	if (mode != 2)
	{
		// No, get the actual MBR
		if (SectorRead (0x00, gDataBuffer) == FALSE)
			return EOF;
	}
	else
	{
		// Yes, make our own
		// Clear the data buffer
		memset (disk->buffer, 0x00, MEDIA_SECTOR_SIZE);
		// Define the data buffer as an MBR
		masterBootRecord = (PT_MBR) disk->buffer;
		// Write in MBR signature
		masterBootRecord->Signature0 = 0x55;     // 0x55
		masterBootRecord->Signature1 = 0xAA;     // 0xAA
		// Boot descriptor = 0x80
		masterBootRecord->Partition0.PTE_BootDes = 0x80;
		// Figure out Cylinder-head-sector address of boot sector
		CHS.sector = (bootSecAddress % 63) + 1;
		CHS.head = (bootSecAddress / 63) % 255;
		CHS.cylinder = (bootSecAddress / 63) / 255;
#ifndef USE_PIC18
		masterBootRecord->Partition0.PTE_FrstPartSect.array[2] = 
				(unsigned char)((((CHS.cylinder << 14) | (CHS.head << 6) |
				(CHS.sector)) & 0xFF0000) >> 16);
		masterBootRecord->Partition0.PTE_FrstPartSect.array[1] = 
				(unsigned char)((((CHS.cylinder << 14) | (CHS.head << 6) |
				(CHS.sector)) & 0x00FF00) >> 8);
		masterBootRecord->Partition0.PTE_FrstPartSect.array[0] = 
				(unsigned char)(((CHS.cylinder << 14) | (CHS.head << 6) |
				(CHS.sector)) & 0x0000FF);
#else
		masterBootRecord->Partition0.PTE_FrstPartSect = 
				((CHS.cylinder << 14) | (CHS.head << 6) |
				(CHS.sector));		
#endif
		// File system descriptor = 0x06 means FAT16
		masterBootRecord->Partition0.PTE_FSDesc = 0x06;
		// Calculate the location of the last partition sector
#ifndef USE_PIC18
		masterBootRecord->Partition0.PTE_LstPartSect.array[2] = 
				(unsigned char)(((long int)(numsectors - bootSecAddress - 1) & 0xFF0000) >> 16);
		masterBootRecord->Partition0.PTE_LstPartSect.array[1] = 
				(unsigned char)(((long int)(numsectors - bootSecAddress - 1) & 0x00FF00) >> 8);
		masterBootRecord->Partition0.PTE_LstPartSect.array[0] = 
				(unsigned char)(((long int)(numsectors - bootSecAddress - 1) & 0x0000FF));
#else
		masterBootRecord->Partition0.PTE_LstPartSect = 
				(numsectors - bootSecAddress - 1);
#endif
		// Set the LBA address of the boot sector
		masterBootRecord->Partition0.PTE_FrstSect = bootSecAddress;
		// Set the total number of sectors in the partition
		masterBootRecord->Partition0.PTE_NumSect = numsectors;
		// Try to write the new MBR to the card
		if (SectorWrite (0, gDataBuffer, TRUE) == FALSE)
				return EOF;
	}

	// Check if the card has no MBR
	BSec = (BootSec) disk->buffer;
	if((BSec->Signature0 == FAT_GOOD_SIGN_0) && (BSec->Signature1 == FAT_GOOD_SIGN_1))
	{
		// Technically, the OEM name is not for indication
		// The alternative is to read the CIS from attribute
		// memory.  See the PCMCIA metaformat for more details
#ifdef USE_PIC24
		if (ReadByte( disk->buffer, BSI_FSTYPE ) == 'F' && \
			ReadByte( disk->buffer, BSI_FSTYPE + 1 ) == 'A' && \
			ReadByte( disk->buffer, BSI_FSTYPE + 2 ) == 'T' && \
			ReadByte( disk->buffer, BSI_FSTYPE + 3 ) == '1' && \
			ReadByte( disk->buffer, BSI_BOOTSIG) == 0x29)
#else
		if (BSec->FAT.FAT_16.BootSec_FSType[0] == 'F' && \
			BSec->FAT.FAT_16.BootSec_FSType[1] == 'A' && \
			BSec->FAT.FAT_16.BootSec_FSType[2] == 'T' && \
			BSec->FAT.FAT_16.BootSec_FSType[3] == '1' && \
			BSec->FAT.FAT_16.BootSec_BootSig == 0x29)
#endif
		{
			// Boot sector is in sector 0 of the device
			// Switch based on the mode
			switch (mode)
			{
				// If we have no MBR we can't make a boot sector
				case 1:
					// not enough info to construct our own boot sector
					return EOF;
					break;
				// Otherwise we're ok
				case 2:
				case 0:
				// We have to determine the operating system, and the 
				// locations and sizes of the root dir and FAT, and the 
				// count of FATs
					disk->firsts = 0;
					LoadBootSector (disk);
					break;
				default:
					// Function called in an invalid mode
					return EOF;
					break;
			}
		}
		else
		{	
			// Sector 0 is a MBR
			masterBootRecord = (PT_MBR) &gDataBuffer;
			disk->firsts = masterBootRecord->Partition0.PTE_FrstSect;
		}
		
	}


	switch (mode)
	{
		// Modes 1 and 2: Rewrite the whole boot sector
		case 1:
		case 2:
			secCount = masterBootRecord->Partition0.PTE_NumSect;
			
			// A sec count of 0x1038 is too small to support FAT16
			if (secCount < 0x1039)
			{
				disk->type = FAT12;
				// Format to FAT12 only if there are too few sectors to format
				// as FAT16.  0x01 is the file system descriptor for 
				// FAT12
				masterBootRecord->Partition0.PTE_FSDesc = 0x01;
				if (SectorWrite (0x00, gDataBuffer, TRUE) == FALSE)
					return EOF;
				
				// A sec count of 0x1028 is too large to support
				// FAT12 with one sector per cluster set
				if (secCount >= 0x1028)
				{
					// More than 0x18 sectors for FATs, 0x20 for root dir, 
					// 0x8 reserved, and 0xFED for data
					// So double the number of sectors in a cluster to reduce
					// the number of data clusters used
					disk->SecPerClus = 2;
				}
				else
				{
					// One sector per cluster
					disk->SecPerClus = 1;
				}
				
				// Prepare a boot sector
				memset (gDataBuffer, 0x00, MEDIA_SECTOR_SIZE);

				// Last digit of file system name (FAT12   )
				gDataBuffer[58] = '2';

			}
			else if (secCount <= 0x3FFD5F)
			{
				// 0x3FFD5F is the max number of sectors for FAT16
				disk->type = FAT16;
				// Format to FAT16
				masterBootRecord->Partition0.PTE_FSDesc = 0x06;
				if (SectorWrite (0x00, gDataBuffer, TRUE) == FALSE)
					return EOF;

				// 0x218 is the number of sectors to use for the
				// FATs, boot sec, reserved sectors, and root dir
				FAT16DataClusters = secCount - 0x218;

				// Figure out how many sectors per cluster we need
				disk->SecPerClus = 1;
				while (FAT16DataClusters > 0xFFED)
				{
					disk->SecPerClus *= 2;
					FAT16DataClusters /= 2;
				}
				// This shouldnt happen
				if (disk->SecPerClus > 128)
					return EOF;

				// Prepare a boot sector
				memset (gDataBuffer, 0x00, MEDIA_SECTOR_SIZE);

				// Last digit of file system name (FAT16   )
				gDataBuffer[58] = '6';

			}
			else
			{
				// Cannot format; too many sectors
				return EOF;
			}

			// Calculate the size of the FAT
			fatsize = (secCount - 0x21  + (2*disk->SecPerClus));
			if (disk->type == FAT12)
				test =	(341 * disk->SecPerClus) + 2;
			else
				test = 	(256  * disk->SecPerClus) + 2;
			fatsize = (fatsize + (test-1)) / test;

			// Non-file system specific values	
			gDataBuffer[0] = 0xEB;			//Jump instruction
			gDataBuffer[1] = 0x3C;
			gDataBuffer[2] =  0x90;
			gDataBuffer[3] =  'M';			//OEM Name "MCHP FAT"
			gDataBuffer[4] =  'C';
			gDataBuffer[5] =  'H'; 
			gDataBuffer[6] =  'P';
			gDataBuffer[7] =  ' ';
			gDataBuffer[8] =  'F';
			gDataBuffer[9] =  'A';
			gDataBuffer[10] =  'T';
			gDataBuffer[11] =  0x00;	        //Bytes per sector - 0x200
			gDataBuffer[12] =  0x02;
			gDataBuffer[13] = disk->SecPerClus;	//Sectors per cluster
			gDataBuffer[14] = 0x08;			//Reserved sector count
			gDataBuffer[15] = 0x00;			// Ours will be 8
			disk->fat = 0x08 + disk->firsts;
			gDataBuffer[16] = 0x02;			//number of FATs
			disk->fatcopy = 0x02;
			gDataBuffer[17] = 0x00; 			//Max number of root directory entries - 512 files allowed
			gDataBuffer[18] = 0x02;
			disk->maxroot = 0x200;
			gDataBuffer[19] = 0x00;			//total sectors	
			gDataBuffer[20] = 0x00;			// 32-bit index
			gDataBuffer[21] = 0xF8;			//Media Descriptor
			gDataBuffer[22] = fatsize & 0xFF;			//Sectors per FAT
			gDataBuffer[23] = (fatsize >> 8) & 0xFF;
			disk->fatsize = fatsize;
			gDataBuffer[24] = 0x3F;	        //Sectors per track 
			gDataBuffer[25] = 0x00;
			gDataBuffer[26] = 0xFF;			//Number of heads 
			gDataBuffer[27] = 0x00;
			// Hidden sectors = sectors between the MBR and the boot sector
			gDataBuffer[28] = (BYTE)(disk->firsts & 0xFF);
			gDataBuffer[29] = (BYTE)((disk->firsts / 0x100) & 0xFF);
			gDataBuffer[30] = (BYTE)((disk->firsts / 0x10000) & 0xFF); 
			gDataBuffer[31] = (BYTE)((disk->firsts / 0x1000000) & 0xFF);
			// Total Sectors = same as sectors in the partition from MBR
			gDataBuffer[32] = (BYTE)(secCount & 0xFF);
			gDataBuffer[33] = (BYTE)((secCount / 0x100) & 0xFF);
			gDataBuffer[34] = (BYTE)((secCount / 0x10000) & 0xFF); 
			gDataBuffer[35] = (BYTE)((secCount / 0x1000000) & 0xFF);
			gDataBuffer[36] = 0x00;			// Physical drive number
			gDataBuffer[37] = 0x00;			// Reserved (current head) 
			gDataBuffer[38] = 0x29;			// Signature code
			gDataBuffer[39] = (BYTE)(serialNumber & 0xFF);
			gDataBuffer[40] = (BYTE)((serialNumber / 0x100) & 0xFF);
			gDataBuffer[41] = (BYTE)((serialNumber / 0x10000) & 0xFF);
			gDataBuffer[42] = (BYTE)((serialNumber / 0x1000000) & 0xFF);
			// Volume ID
			if (volumeID != NULL)
			{
				for (i = 0; (*(volumeID + i) != 0) && (i < 11); i++)
				{
					gDataBuffer[i + 43] = *(volumeID + i);
				}
				while (i < 11)
				{
					gDataBuffer[43 + i++] = 0x20;
				}
			}
			else
			{
				for (i = 0; i < 11; i++)
				{
					gDataBuffer[i+43] = 0;
				}
			}
			// File system name- we already wrote the last char
			// into gDataBuffer[58]
			gDataBuffer[54] = 'F';
			gDataBuffer[55] = 'A';
			gDataBuffer[56] = 'T';
			gDataBuffer[57] = '1';
			gDataBuffer[59] = ' ';
			gDataBuffer[60] = ' ';
			gDataBuffer[61] = ' ';
			// Signature code
			gDataBuffer[510] = 0x55;
			gDataBuffer[511] = 0xAA;
			
	        disk->root = disk->fat + (disk->fatcopy * disk->fatsize);

			// Write our new boot sector to the card
			if (SectorWrite (disk->firsts, gDataBuffer, FALSE) == FALSE)
				return EOF;
			
			break;
		// Mode 0: just load the existing boot sector
		case 0:
			if (LoadBootSector (disk) != CE_GOOD)
				return EOF;
			break;
		default:
			return EOF;
	}

	// Erase the FAT
	memset (gDataBuffer, 0x00, MEDIA_SECTOR_SIZE);
	// Clusters 0 and 1 aren't used- put the EOF value in there
	gDataBuffer[0] = 0xF8;
	gDataBuffer[1] = 0xFF;
	gDataBuffer[2] = 0xFF;
	if (disk->type == FAT16)
		gDataBuffer[3] = 0xFF;

	// Write this first sector into every copy of the FAT
	for (j = disk->fatcopy - 1; j != 0xFFFF; j--)
	{
		if (SectorWrite (disk->fat + (j * disk->fatsize), gDataBuffer, FALSE) == FALSE)
			return EOF;
	}
			
	// Zero out those first two values again
	memset (gDataBuffer, 0x00, 4);

	// Write all zeros to every sector of each FAT except the first sector	
	for (i = disk->fat + 1; i < (disk->fat + disk->fatsize); i++)
	{
		for (j = disk->fatcopy - 1; j != 0xFFFF; j--)
		{
			if (SectorWrite (i + (j * disk->fatsize), gDataBuffer, FALSE) == FALSE)
				return EOF;
		}
	}

	// Erase the root directory
	RootDirSectors = ((disk->maxroot * 32) + (0x200 - 1)) / 0x200;               

	for (i = 1; i < RootDirSectors; i++)
	{
		if (SectorWrite (disk->root + i, gDataBuffer, FALSE) == FALSE)
			return EOF;
	}

	// Create a drive name entry in the root dir
	if (volumeID != NULL)
	{
		// Create a drive name entry in the root dir
		i = 0;
		while ((*(volumeID + i) != 0) && (i < 11))
		{
			gDataBuffer[i] = *(volumeID + i);
			i++;
		}
		while (i < 11)
		{
			gDataBuffer[i++] = ' ';
		}
		gDataBuffer[11] = 0x08;
		gDataBuffer[17] = 0x11;
		gDataBuffer[19] = 0x11;
		gDataBuffer[23] = 0x11;
		
		if (SectorWrite (disk->root, gDataBuffer, FALSE) == FALSE)
			return EOF;
	}	
	else
	{
		if (SectorWrite (disk->root, gDataBuffer, FALSE) == FALSE)
			return EOF;
	}

	return 0;
}
#endif
/****************************************************************/
/*                    END OF YOUR CODE                          */
/****************************************************************/


#endif
#endif
