

#ifndef _USER_H
#define _USER_H


#include "GenericTypeDefs.h"
#include "usb_config.h"

// LEDs

#define R_LED_RED      PORTBbits.RB4
#define R_LED_YELLOW   PORTBbits.RB5

#define L_LED_RED      LATBbits.LATB4
#define L_LED_YELLOW   LATBbits.LATB5

#define TRIS_LED TRISBbits.TRISB4=0;\
                 TRISBbits.TRISB5=0

#define LED_ON     0
#define LED_OFF    1

#define LED_RED        R_LED_RED
#define LED_YELLOW     R_LED_YELLOW

#define LED_RED_FLIP     R_LED_RED    = !L_LED_RED
#define LED_YELLOW_FLIP  R_LED_YELLOW = !L_LED_YELLOW

#define LED_YELLOW_ON    LED_YELLOW = LED_ON
#define LED_YELLOW_OFF   LED_YELLOW = LED_OFF
#define LED_RED_ON       LED_RED    = LED_ON
#define LED_RED_OFF      LED_RED    = LED_OFF

// inputs

#define R_MODE        PORTBbits.RB3
#define R_RESET       PORTDbits.RD1
#define R_START_STOP  PORTDbits.RD0

#define TRIS_P TRISBbits.TRISB3=1;\
               TRISDbits.TRISD0=1;\
               TRISDbits.TRISD1=1;
               

// map the toggle start/stop button values
#define TOGGLE_STOP   TOGGLE_ZERO
#define TOGGLE_START  TOGGLE_ONE

#define MODE_CURRENT  0
#define MODE_VOLTAGE  1

#define P_MODE_CURRENT (R_MODE == MODE_CURRENT)
#define P_MODE_VOLTAGE (R_MODE == MODE_VOLTAGE)

#define P_RESET  (R_RESET == 0)





#define P_USB    (PORTDbits.RD4 == 1)
/** P U B L I C  P R O T O T Y P E S *****************************************/


int SD_Card_Initialize(void);
void SD_Card_Init(void);

void UserInit(void);
void ProcessIO(void);

#endif 
