
#ifndef _MY_NO_STRING_H
 #include <string.h>
#endif

// #include <stdio.h>

#include "user_common.h"

void pack_C(DATA_PACKET* P, BYTE CMD)
  {
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
  }


void pack_C2(DATA_PACKET* P, BYTE CMD, UINT16 delay)
  {
    unsigned char *ptr;
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
    
    ptr = (unsigned char*) &delay;
    P->b[1] = ptr[0];
    P->b[2] = ptr[1];    
  }     
  
void pack_C22(DATA_PACKET* P, BYTE CMD, UINT16 delay, UINT16 value)
  {
    unsigned char *ptr;
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
    
    ptr = (unsigned char*) &delay;
    P->b[1] = ptr[0];
    P->b[2] = ptr[1];    

    ptr = (unsigned char*) &value;
    P->b[3] = ptr[0];
    P->b[4] = ptr[1];   
  }     
    
void pack_C4(DATA_PACKET* P, BYTE CMD, UINT32 value)
  {
    unsigned char *ptr;
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
    
    ptr = (unsigned char*) &value;
    P->b[1] = ptr[0];
    P->b[2] = ptr[1];  
    P->b[3] = ptr[2];
    P->b[4] = ptr[3];  
  }

void pack_C44(DATA_PACKET* P, BYTE CMD, UINT32 value1, UINT32 value2)
  {
    unsigned char *ptr;
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
    
    ptr = (unsigned char*) &value1;
    P->b[1] = ptr[0];
    P->b[2] = ptr[1];  
    P->b[3] = ptr[2];
    P->b[4] = ptr[3];  
    
  
    ptr = (unsigned char*) &value2;
    P->b[5] = ptr[0];
    P->b[6] = ptr[1];  
    P->b[7] = ptr[2];
    P->b[8] = ptr[3];      
  }

void pack_bulk_C(DATA_PACKET* P, BYTE CMD)
  {
    memset(P,0, DATA_PACKET_SIZE);
    P->b[0] = CMD;
  }
  
void pack_bulk_n22(DATA_PACKET* P, BYTE n, UINT16 delay, UINT16 value)
  {
    // n = [0..14]
    // 15*4+1 =61
    unsigned char *ptr;
    int offset;
    
    offset = 4*n;
    
    ptr = (unsigned char*) &delay;
    P->b[1+offset] = ptr[0];
    P->b[2+offset] = ptr[1];    

    ptr = (unsigned char*) &value;
    P->b[3+offset] = ptr[0];
    P->b[4+offset] = ptr[1];   
  }       

/*
 *  unpack commands
 */
 
 

void unpack_C2(DATA_PACKET* P, BYTE* CMD, UINT16* delay)
  {
    unsigned char *ptr;
    *CMD = P->b[0];

    ptr = (unsigned char*) delay;
    ptr[0] = P->b[1];
    ptr[1] = P->b[2];
  }


void unpack_C22(DATA_PACKET* P, BYTE* CMD, UINT16* delay, UINT16* value)
  {
    unsigned char *ptr;
    *CMD = P->b[0];

    ptr = (unsigned char*) delay;
    ptr[0] = P->b[1];
    ptr[1] = P->b[2];    

    ptr = (unsigned char*) value;
    ptr[0] = P->b[3];
    ptr[1] = P->b[4];   
  }

void unpack_C4(DATA_PACKET* P, BYTE* CMD, UINT32* value)
  {
    unsigned char *ptr;
    *CMD = P->b[0];

    ptr = (unsigned char*) value;
    ptr[0] = P->b[1];
    // printf("ptr[0] = %.2x, ptr[1]= %.2x\n",ptr[0],ptr[1]);
    ptr[1] = P->b[2];  
    ptr[2] = P->b[3];
    ptr[3] = P->b[4];  
  }


void unpack_C44(DATA_PACKET* P, BYTE* CMD, UINT32* value1, UINT32* value2)
  {
    unsigned char *ptr;
    *CMD = P->b[0];
    
    ptr = (unsigned char*) value1;
    ptr[0] = P->b[1];
    ptr[1] = P->b[2];  
    ptr[2] = P->b[3];
    ptr[3] = P->b[4];  
    
    ptr = (unsigned char*) value2;
    ptr[0] = P->b[5];
    ptr[1] = P->b[6];  
    ptr[2] = P->b[7];
    ptr[3] = P->b[8];  
  }
  
void unpack_bulk_C(DATA_PACKET* P, BYTE* CMD)
  {
    *CMD = P->b[0];
  }
  
void unpack_bulk_n22(DATA_PACKET* P, BYTE n, UINT16* delay, UINT16* value)
  {
    // n = [0..14]
    // 15*4+1 =61
    unsigned char *ptr;
    int offset;
    
    offset = 4*n;
    
    ptr = (unsigned char*) delay;
    ptr[0] = P->b[1+offset];
    ptr[1] = P->b[2+offset];    

    ptr = (unsigned char*) value;
    ptr[0] = P->b[3+offset];
    ptr[1] = P->b[4+offset];   
  }       
