

#ifndef _USER_COMMON_H
#define _USER_COMMON_H

#ifndef _MY_LINUX_KERNEL_MODULE
  #include "GenericTypeDefs.h"
#endif

#ifdef _MY_LINUX_KERNEL_MODULE
  typedef unsigned char       BYTE;
  typedef signed short int    INT;
  typedef signed char         INT8;
  typedef signed short int    INT16;
  typedef signed long         INT32;
  typedef signed long long    INT64;
  
  typedef unsigned short int    UINT;
  typedef unsigned char         UINT8;
  typedef unsigned short int    UINT16;
  typedef unsigned long         UINT32;
  typedef unsigned long long    UINT64;
#endif

#define CMD_SIZE 1
#define CMD_TYPE BYTE

#define USBGEN_EP_SIZE  64

#define DATA_PACKET_SIZE sizeof(DATA_PACKET)


// COMMANDS
#define CMD_REQ_PING        10
#define CMD_ANS_PONG        11
#define CMD_REQ_SEC_COUNT   12
#define CMD_REQ_SDTEST_GET  13
#define CMD_REQ_SDTEST_PUT  14
#define CMD_OK              15
#define CMD_ERR             16
#define CMD_ERR_EOF         17
#define CMD_ANS_DATA        18
#define CMD_REQ_SOF         19
#define CMD_REQ_BULK        20
#define CMD_ANS_BULK        21
#define CMD_REQ_ERASE       22
#define CMD_REQ_SIZE        23

//#define CMD_SET_PCMD        24
#define CMD_SET_PTEST       25
#define CMD_GET_PTEST       26
#define CMD_VAL_PTEST       27



typedef struct DATA_PACKET {
    UINT8 b[USBGEN_EP_SIZE];
} DATA_PACKET;

void pack_C(DATA_PACKET* P, BYTE CMD);

void pack_C2(DATA_PACKET* P, BYTE CMD, UINT16 delay);
void pack_C22(DATA_PACKET* P, BYTE CMD, UINT16 delay, UINT16 value);
void pack_C4(DATA_PACKET* P, BYTE CMD, UINT32 value);
void pack_C44(DATA_PACKET* P, BYTE CMD, UINT32 value1, UINT32 value2);
void pack_bulk_C(DATA_PACKET* P, BYTE CMD);
void pack_bulk_n22(DATA_PACKET* P, BYTE n, UINT16 delay, UINT16 value);

void unpack_C2(DATA_PACKET* P, BYTE* CMD, UINT16* delay);
void unpack_C22(DATA_PACKET* P, BYTE* CMD, UINT16* delay, UINT16* value);
void unpack_C4(DATA_PACKET* P, BYTE* CMD, UINT32* value);
void unpack_C44(DATA_PACKET* P, BYTE* CMD, UINT32* value1, UINT32* value2);
void unpack_bulk_C(DATA_PACKET* P, BYTE* CMD);
void unpack_bulk_n22(DATA_PACKET* P, BYTE n, UINT16* delay, UINT16* value);

#endif 
