package MyGraph;

use strict;

sub new 
  {
    my $pkg = shift;

    my $obj = {
      'T0_TICK' =>  0.000000666666666666667,  # t0 seconds per t0 tick
      'AMP'    =>  1000/1024,  # 1000 Amps = 1024 Units
      'VOLT'   =>  0.249266862,  # (R1+R2)*5/(R2*1023)
    };

    bless $obj, $pkg;
    return $obj;
  }

sub split
  {
    my $obj = shift;
    my $line = shift;

    my ($delay,$value) = ($line =~ /(\d+)\s*,\s*(\d+)/);

    return ($delay,$value);
  }

sub toSeconds
  {
    my $obj = shift;
    my $time = shift;

    # my $seconds = $obj->{'T0_TICK'} * $time * 4;
    my $seconds = $obj->{'T0_TICK'} * $time;

    return $seconds;
  }

sub toAmps
  {
    my $obj = shift;
    my $value = shift;

    my $current = $obj->{'AMP'} * $value;

    return $current;
  }

sub toVolts
  {
    my $obj = shift;
    my $value = shift;

    my $volts = $obj->{'VOLT'} * $value;

    return $volts;
  }

return 1;
