#!/usr/bin/perl -I..

use Chart::Gnuplot;

use MyGraph;

use strict;

my $data_log = shift || 'sd_download.log';
my $image = shift || 'graph.png';

my $start = shift || 0;
my $stop = shift || 0;

if ($start && (!$stop))
  {
    $start = $start + 10;
  }

my @time;
my @value;

my $count = 0;
my $total_records = 0;

my $time = 0;


my $obj = new MyGraph();

open(IN,$data_log) || die "Cannot open data file: '$data_log'\n";
while (my $line = <IN>)
  {
    $count++;
    $total_records++;
    if ($count>500)
      {
        print "Read $total_records records\n";
        $count = 0;
      }

    chop($line);
    my ($delay,$value) = split(/,/,$line);

    # print "($time,$value)\n";

    $time = $time + $delay;
    my $seconds = $obj->toSeconds($time);
    my $volts = $obj->toVolts($value);

    if ($start && $stop)
      {
        next if ($seconds<$start);
        next if ($seconds>$stop);
      }


    # print "($seconds,$volts)\n";
    push(@time, $seconds);
    push(@value, $volts);


  }
close(IN);

my $total_time = $obj->toSeconds($time);
print "Records/Second = " . $total_records/$total_time . "\n" if ( (!$start) && (!$stop));

print "Making graph\n";

# Create chart object and specify the properties of the chart
my $chart = Chart::Gnuplot->new(
    output => $image,
    title  => "",
    xlabel => "Seconds",
    # ylabel => "Voltage",
    ylabel => {
        text => "                                    Volts",
        color => "#FF0000",
      },
    imagesize => "1.5, 1",
    border => {
      linetype => 'solid',
      width    => 2,
      color    => '#FF0000',
    },

  );
    
# Create dataset object and specify the properties of the dataset
my $dataSet = Chart::Gnuplot::DataSet->new(
    xdata => \@time,
    ydata => \@value,
    color => "#FF0000",
    # title => "Plotting a line from Perl arrays",
    # style => "linespoints",
    # style => "lines",
    # style => "points",
    style => "dots",
  );
    
# Plot the data set on the chart
$chart->plot2d($dataSet);



sub avg
  {
    my $sum = 0;
    my $count = 0;
    foreach my $value (@_)
      {
        $sum = $sum + $value;
        $count++;
      }
    return int($sum/$count)
  }


