#!/usr/bin/perl

use strict;

use GD::Graph::lines;

my $data_log = shift || 'sd_download.log';

open(IN,$data_log) || die "Cannot open data file: '$data_log'\n";


my @time;
my @value;

my $count = 0;
my $time = 0;
my $space = 0;

my @space = (
        "(",
        " \\",
        "  \\",
        "   \\",
        "    )",
        "   /",
        "  /",
        " /"
      );

while (my $line = <IN>)
  {
    $count++;
    if ($count>500)
      {
        $space = (++$space) % 8;
        my $s = $space[$space];
        print "Read 500 records $s\n";
        $count = 0;
      }

    chop($line);
    my ($delay,$value) = split(/,/,$line);

    # next unless ($delay);
    # next unless ($value);
  
    push(@time, $time);
    push(@value, $value);

    # print "($time,$value)\n";

    $time = $time + $delay;
  }

close(IN);
print "Making graph\n";


my @data = ( [@time], [@value]);
my $data_points =  int($#time/100);

my $graph = new GD::Graph::lines(800,600);
$graph->set(
        x_label => 'time',
        y_label => 'value',
        title   => 'my graph',
        x_ticks => int($data_points/4),
        # y_min_value   => $graph_info->{y_min},
        # y_max_value   => 1100,
      #  x_label_skip => $data_points,
#        x_tick_number => 'auto',
#        x_tick_number => 1,
      #  x_labels_vertical => 1,
        y_long_ticks => 1,
        dclrs => ['orange'],

);

# print CGI::header(-type => "image/png", -expires => "-1d");
# print "Content-Type: image/png; charset=ISO-8859-1\n\n";

print "Writing graph\n";

open(OUT,">graph.png") || die "Cannot create output file\n";
my $image = $graph->plot(\@data);
print OUT $image->png();
close(OUT);

print "DONE\n\n";

sub space_data
  {



  }



