#!/usr/bin/perl

use Chart::Gnuplot;
use strict;

my $data_log = shift || 'sd_download.log';
my $image = shift || 'graph.png';


my @time;
my @value;

my $count = 0;
my $time = 0;

open(IN,$data_log) || die "Cannot open data file: '$data_log'\n";
while (my $line = <IN>)
  {
    $count++;
    if ($count>500)
      {
        print "Read 500 records\n";
        $count = 0;
      }

    chop($line);
    my ($delay,$value) = split(/,/,$line);

    push(@time, $time);
    push(@value, $value);

    # print "($time,$value)\n";

    $time = $time + $delay;
  }
close(IN);

print "Making graph\n";

# Create chart object and specify the properties of the chart
my $chart = Chart::Gnuplot->new(
    output => $image,
    title  => "Data Meter",
    xlabel => "Time",
    ylabel => "Value",
  );
    
# Create dataset object and specify the properties of the dataset
my $dataSet = Chart::Gnuplot::DataSet->new(
    xdata => \@time,
    ydata => \@value,
    # title => "Plotting a line from Perl arrays",
    # style => "linespoints",
    style => "lines",
  );
    
# Plot the data set on the chart
$chart->plot2d($dataSet);






