#!/usr/bin/perl

use strict;
use Chart::Gnuplot;

use MyGraph;



my $data_log = shift || 'sd_download.log';
my $image = shift || 'graph.png';


my @time;
my @value;

my $count = 0;
my $time = 0;

my $obj = new MyGraph();

open(IN,$data_log) || die "Cannot open data file: '$data_log'\n";
while (my $line = <IN>)
  {
    $count++;
    if ($count>500)
      {
        print "Read 500 records\n";
        $count = 0;
      }

    my ($delay,$value) = $obj->split($line);

    $time = $time + $delay;
    my $seconds = $obj->toSeconds($time);
    my $amps = $obj->toAmps($value);


    push(@time, $seconds);
    push(@value, $amps);

    # print "($time,$value)\n";

  }
close(IN);

print "Making graph\n";

# Create chart object and specify the properties of the chart
my $chart = Chart::Gnuplot->new(
    output => $image,
    # title  => "Data Meter",
    xlabel => "Seconds",
    ylabel => "Amps",
    imagesize => "1.5, 1",
    ylabel => {
        text => "Amps",
        color => "#0000FF",
      },
    imagesize => "1.5, 1",
    border => {
      linetype => 'solid',
      width    => 2,
      color    => '#0000FF',
    },

  );
    
# Create dataset object and specify the properties of the dataset
my $dataSet = Chart::Gnuplot::DataSet->new(
    xdata => \@time,
    ydata => \@value,
    # title => "Plotting a line from Perl arrays",
    # style => "linespoints",
    # style => "lines",
    color => "#0000FF",

    style => "dots",
  );
    
# Plot the data set on the chart
$chart->plot2d($dataSet);






