#!/usr/bin/perl

use Chart::Gnuplot;
use strict;

my $data_log = 'sd_download.log';
my $image = 'graph.png';
my $start_time = shift || 0;
my $stop_time = shift || $start_time+5;

my $t0_tick = 0.000000666666666666667;  # t0 seconds per t0 tick 


my @time;
my @value;

my $count = 0;
my $time = 0;

my $seconds = 0;

open(IN,$data_log) || die "Cannot open data file: '$data_log'\n";
while (my $line = <IN>)
  {


    chop($line);
    my ($delay,$value) = split(/,/,$line);

    $time = $time + $delay;
    $seconds = $t0_tick*$time*4;

# print "TIME = $seconds\n";

    next if ($seconds < $start_time);
    last if ($seconds > $stop_time);

    push(@time, $time);
    push(@value, $value);

    $count++;
    if ($count>500)
      {
        print "Read 500 records... Seconds: $seconds\n";
        $count = 0;
      }

    # print "($time,$value)\n";

#    $seconds = $seconds + $t0_tick*$time*4;
#    $time = $time + $delay;
  }
close(IN);

print "Making graph\n";

# Create chart object and specify the properties of the chart
my $chart = Chart::Gnuplot->new(
    output => $image,
    title  => "Data Meter",
    xlabel => "Time",
    ylabel => "Value",
  );
    
# Create dataset object and specify the properties of the dataset
my $dataSet = Chart::Gnuplot::DataSet->new(
    xdata => \@time,
    ydata => \@value,
    # title => "Plotting a line from Perl arrays",
    # style => "linespoints",
    style => "lines",
  );
    
# Plot the data set on the chart
$chart->plot2d($dataSet);






