

#ifndef MY_SD_CARD_H
#define MY_SD_CARD_H


#include "GenericTypeDefs.h"


   
#ifdef MY_LINUX_TESTING
  #define SECTOR_SIZE  16*4
  #define SECTOR_COUNT_MAX 10L
#else
  #include "MDD File System/SD-SPI.h"
  #define SECTOR_SIZE 512
  #define SECTOR_COUNT_MAX 1900000L
#endif

typedef struct my_record {
       unsigned int delay;  // 2 bytes
       unsigned int value;  // 2 bytes
} my_record;

#define RECORD_TYPE my_record
#define RECORD_SIZE sizeof(RECORD_TYPE)

// move the pointer to the start of the card.
void SD_seek_sof(void); 
//void SD_ptr_eoc(void); 


int SD_erase(void);
int SD_write(RECORD_TYPE *ptr);
RECORD_TYPE* SD_read(unsigned long max_sector); 

unsigned long SD_get_sector_value(void);
void SD_set_sector_value(unsigned long value);

int SD_flush(void); 

#endif 
