
#include "led_disp.h"
#include <p18f4550.h>

static int MIKE_LED_1 = 0;
static int MIKE_LED_2 = 0;
static int MIKE_LED_3 = 0;
static int display_number = 0;

void mike_init_display()
  {
    TRIS_DISP;
  }
  
void mike_update_display(int value)
  {
    MIKE_LED_3 = value - 10*(value/10);       // 12345 => 12345 - 10*1234 = 5
    MIKE_LED_2 = value/10 - 10*(value/100);   // 12345 =>  1234 - 10*123  = 1234-1230 = 4
    MIKE_LED_1 = value/100 - 10*(value/1000); // 12345 =>   123 - 10*12   = 123 - 120 = 3
  }

void mike_refresh_display(void)
  {  
    switch (display_number)
      {
        case 0: mike_set_led(1, MIKE_LED_1); break;
        case 1: mike_set_led(2, MIKE_LED_2); break;
        case 2: mike_set_led(3, MIKE_LED_3); break;
      }
     display_number = (display_number+1)%3;     
  }
 

void mike_set_led(int n, int value)
  {
    DISP_OFF;
     
    switch(value)
      {
        case 8: DISP_F_ON;
                DISP_E_ON;
        case 3: DISP_G_ON;
                DISP_D_ON;
        case 7: DISP_A_ON;
        case 1: DISP_B_ON;
                DISP_C_ON;
                break;
        case 2:
                DISP_A_ON;
                DISP_B_ON;
                DISP_G_ON;
                DISP_E_ON;
                DISP_D_ON;
                break;
               
        case 9: DISP_A_ON;
        case 4: DISP_F_ON;
                DISP_G_ON;
                DISP_B_ON;
                DISP_C_ON;
                break;
               
        case 6: DISP_E_ON;
        case 5: DISP_A_ON;
                DISP_F_ON;
                DISP_G_ON;
                DISP_C_ON;
                DISP_D_ON;
                break;
               
        case 0: DISP_F_ON;
                DISP_E_ON;
                DISP_D_ON;
                DISP_A_ON;
                DISP_B_ON;
                DISP_C_ON;
                break;
      } 
       
    switch(n)
      {
         case 1: DISP_1_ON; break;
         case 2: DISP_2_ON; break;
         case 3: DISP_3_ON; break;
      }
  }
